
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Interface for Other Plugins &#8212; PythonScript 1.5.4.0 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Compiling PythonScript" href="compiling.html" />
    <link rel="prev" title="Enums" href="enums.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="compiling.html" title="Compiling PythonScript"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="enums.html" title="Enums"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">PythonScript 1.5.4.0 documentation</a> &#187;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="interface-for-other-plugins">
<h1>Interface for Other Plugins<a class="headerlink" href="#interface-for-other-plugins" title="Permalink to this headline">¶</a></h1>
<p>For plugin authors, you can run <a class="reference external" href="https://www.python.org/">Python</a> scripts and expressions by calling Python Script remotely.  For this we use the Notepad++ message <code class="docutils literal notranslate"><span class="pre">NPPM_MSGTOPLUGIN</span></code>.</p>
<p>I’ll give instructions for C / C++, other languages you’ll need to convert the interface to - any submissions for other languages are welcome!</p>
<p>First <code class="docutils literal notranslate"><span class="pre">#include</span> <span class="pre">&quot;PythonScript/NppPluginScript.h&quot;</span></code> from the PythonScriptinclude directory in the source archive.  The following instructions are also contained in this file.</p>
<p>A <code class="docutils literal notranslate"><span class="pre">struct</span></code> is defined in this file called <code class="docutils literal notranslate"><span class="pre">PythonScript_Exec</span></code>.  This <code class="docutils literal notranslate"><span class="pre">struct</span></code> has a few members as follows.:</p>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="k">struct</span> <span class="n">PythonScript_Exec</span>
<span class="p">{</span>
        <span class="c1">/// PythonScript_Exec structure version - must always be 1</span>
        <span class="kt">int</span> <span class="n">structVersion</span><span class="p">;</span>

        <span class="c1">/// Python Script (for PYSCR_EXECSTATEMENT) or absolute filename (for PYSCR_EXECSCRIPT)</span>
        <span class="n">TCHAR</span> <span class="o">*</span><span class="n">script</span><span class="p">;</span>

        <span class="cm">/** HANDLE to an event created with CreateEvent.  This event is signalled (with SetEvent)</span>
<span class="cm">         *  when the script has completed.</span>
<span class="cm">         *  This can be NULL, in which case no event is signalled</span>
<span class="cm">         *</span>
<span class="cm">         *  Important: Do NOT wait on the handle on the thread that Notepad++ runs on</span>
<span class="cm">         *  (ie. the plugin default thread) unless you really know what you are doing :)</span>
<span class="cm">         *  It will almost certainly deadlock (as Scintilla or N++ may need to process a message)</span>
<span class="cm">         */</span>

        <span class="n">HANDLE</span> <span class="n">completedEvent</span><span class="p">;</span>

        <span class="cm">/** Flags for running the script</span>
<span class="cm">         *  Combination of PYSCRF_xxxxx constants</span>
<span class="cm">         */</span>
        <span class="kt">int</span> <span class="n">flags</span><span class="p">;</span>

        <span class="cm">/** PythonScripts sets this to TRUE when the PythonScript plugin</span>
<span class="cm">         *  has successfully received the message.</span>
<span class="cm">         *  Note that a TRUE here does NOT mean the script has run, or ran without</span>
<span class="cm">         *  errors, merely that the script has been added to the queue to run</span>
<span class="cm">         *</span>
<span class="cm">         *  You should set this to FALSE initially, and check for TRUE when SendMessage() returns.</span>
<span class="cm">         */</span>
        <span class="n">BOOL</span> <span class="n">deliverySuccess</span><span class="p">;</span>
<span class="p">};</span>
</pre></div>
</div>
<p>There are two messages you can use - <code class="docutils literal notranslate"><span class="pre">PYSCR_EXECSCRIPT</span></code> and <code class="docutils literal notranslate"><span class="pre">PYSCR_EXECSTATEMENT</span></code>.  For the first, you pass the absolute filename of the script you wish to run, the second, you pass the statement directly.</p>
<p>Here’s a sample of how to call NPPM_MSGTOPLUGIN.:</p>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="kt">void</span> <span class="nf">callPython</span><span class="p">()</span>
<span class="p">{</span>
        <span class="n">PythonScript_Exec</span> <span class="n">pse</span><span class="p">;</span>
        <span class="n">pse</span><span class="p">.</span><span class="n">structVersion</span> <span class="o">=</span> <span class="mi">1</span><span class="p">;</span>

        <span class="n">HANDLE</span> <span class="n">completeEvent</span> <span class="o">=</span> <span class="n">CreateEvent</span><span class="p">(</span><span class="nb">NULL</span><span class="p">,</span> <span class="n">TRUE</span><span class="p">,</span> <span class="n">FALSE</span><span class="p">,</span> <span class="nb">NULL</span><span class="p">);</span>

        <span class="n">pse</span><span class="p">.</span><span class="n">completedEvent</span> <span class="o">=</span> <span class="n">completeEvent</span><span class="p">;</span>
        <span class="n">pse</span><span class="p">.</span><span class="n">deliverySuccess</span> <span class="o">=</span> <span class="n">FALSE</span><span class="p">;</span>

        <span class="n">TCHAR</span> <span class="n">script</span><span class="p">[]</span> <span class="o">=</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;e:</span><span class="se">\\</span><span class="s">script_to_run.py&quot;</span><span class="p">);</span>
        <span class="n">pse</span><span class="p">.</span><span class="n">script</span> <span class="o">=</span> <span class="n">script</span><span class="p">;</span>
        <span class="n">pse</span><span class="p">.</span><span class="n">flags</span> <span class="o">=</span> <span class="n">PYSCRF_SYNC</span><span class="p">;</span>


        <span class="n">TCHAR</span> <span class="n">pluginName</span><span class="p">[]</span> <span class="o">=</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;PythonScript.dll&quot;</span><span class="p">);</span>
        <span class="n">CommunicationInfo</span> <span class="n">commInfo</span><span class="p">;</span>
        <span class="n">commInfo</span><span class="p">.</span><span class="n">internalMsg</span> <span class="o">=</span> <span class="n">PYSCR_EXECSCRIPT</span><span class="p">;</span>
        <span class="n">commInfo</span><span class="p">.</span><span class="n">srcModuleName</span> <span class="o">=</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;MyPlugin.dll&quot;</span><span class="p">);</span>

        <span class="n">commInfo</span><span class="p">.</span><span class="n">info</span> <span class="o">=</span> <span class="n">reinterpret_cast</span><span class="o">&lt;</span><span class="kt">void</span><span class="o">*&gt;</span><span class="p">(</span><span class="o">&amp;</span><span class="n">pse</span><span class="p">);</span>

        <span class="n">BOOL</span> <span class="n">delivery</span> <span class="o">=</span> <span class="n">SendMessage</span><span class="p">(</span><span class="n">nppData</span><span class="p">.</span><span class="n">_nppHandle</span><span class="p">,</span> <span class="n">NPPM_MSGTOPLUGIN</span><span class="p">,</span> <span class="n">reinterpret_cast</span><span class="o">&lt;</span><span class="n">WPARAM</span><span class="o">&gt;</span><span class="p">(</span><span class="n">pluginName</span><span class="p">),</span> <span class="n">reinterpret_cast</span><span class="o">&lt;</span><span class="n">LPARAM</span><span class="o">&gt;</span><span class="p">(</span><span class="o">&amp;</span><span class="n">commInfo</span><span class="p">));</span>
        <span class="k">if</span> <span class="p">(</span><span class="o">!</span><span class="n">delivery</span><span class="p">)</span>
        <span class="p">{</span>
                <span class="n">MessageBox</span><span class="p">(</span><span class="nb">NULL</span><span class="p">,</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;Python Script not found&quot;</span><span class="p">),</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;Msg2PluginTester&quot;</span><span class="p">),</span> <span class="mi">0</span><span class="p">);</span>
        <span class="p">}</span>


        <span class="k">if</span> <span class="p">(</span><span class="n">pse</span><span class="p">.</span><span class="n">deliverySuccess</span><span class="p">)</span>
        <span class="p">{</span>
                <span class="n">MessageBox</span><span class="p">(</span><span class="nb">NULL</span><span class="p">,</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;Delivery Success&quot;</span><span class="p">),</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;Msg2PluginTester&quot;</span><span class="p">),</span> <span class="mi">0</span><span class="p">);</span>
        <span class="p">}</span>
        <span class="k">else</span>
        <span class="p">{</span>
                <span class="n">MessageBox</span><span class="p">(</span><span class="nb">NULL</span><span class="p">,</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;Delivery FAILED!&quot;</span><span class="p">),</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;Msg2PluginTester&quot;</span><span class="p">),</span> <span class="mi">0</span><span class="p">);</span>
        <span class="p">}</span>

        <span class="c1">// Optionally now start a thread to wait for the completion</span>
        <span class="n">CreateThread</span><span class="p">(</span><span class="nb">NULL</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="p">(</span><span class="n">LPTHREAD_START_ROUTINE</span><span class="p">)</span><span class="n">threadRun</span><span class="p">,</span> <span class="p">(</span><span class="n">LPVOID</span><span class="p">)</span><span class="n">completeEvent</span><span class="p">,</span> <span class="mi">0</span><span class="p">,</span> <span class="nb">NULL</span><span class="p">);</span>
<span class="p">}</span>
<span class="p">...</span>

<span class="kt">void</span> <span class="n">threadRun</span><span class="p">(</span><span class="n">HANDLE</span> <span class="n">waitEvent</span><span class="p">)</span>
<span class="p">{</span>
        <span class="n">WaitForSingleObject</span><span class="p">(</span><span class="n">waitEvent</span><span class="p">,</span> <span class="n">INFINITE</span><span class="p">);</span>
        <span class="n">MessageBox</span><span class="p">(</span><span class="nb">NULL</span><span class="p">,</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;Finished!&quot;</span><span class="p">),</span> <span class="n">_T</span><span class="p">(</span><span class="s">&quot;I waited...&quot;</span><span class="p">),</span> <span class="mi">0</span><span class="p">);</span>
<span class="p">}</span>
</pre></div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="enums.html"
                        title="previous chapter">Enums</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="compiling.html"
                        title="next chapter">Compiling PythonScript</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/otherplugins.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="compiling.html" title="Compiling PythonScript"
             >next</a> |</li>
        <li class="right" >
          <a href="enums.html" title="Enums"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">PythonScript 1.5.4.0 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010,2014,2018 Dave Brotherstone.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>